#include <math.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "EvalExpr2.h"
#define TAMANOEXPRESION 1500

EvalExpr2::EvalExpr2(void)
{
		//Las funciones sern siempre tres letras
    	strcpy(sbFuncion[1],"sin"); //seno
		strcpy(sbFuncion[2],"sen"); //seno
		strcpy(sbFuncion[3],"cos"); //coseno
		strcpy(sbFuncion[4],"tan"); //tangente
		strcpy(sbFuncion[5],"abs"); //valor absoluto
		strcpy(sbFuncion[6],"asn"); //arcoseno
		strcpy(sbFuncion[7],"acs"); //arcocoseno
		strcpy(sbFuncion[8],"atn"); //arcotangente
		strcpy(sbFuncion[9],"log"); //logaritmo
		strcpy(sbFuncion[10],"int"); //valor entero redondeado
		strcpy(sbFuncion[11],"exp"); //exponencial
		strcpy(sbFuncion[12],"sqr"); //Raiz cuadrada
		strcpy(sbFuncion[13],"rcb"); //Raiz cubica
}

//Por compatibilidad hacia atrs...
float EvalExpr2::fCapturaEcuacion(char *sbEcuacion, float fX, float fY)
{
	fVariable['x'-'a']=fX;
	fVariable['y'-'a']=fY;
	
	return fEvaluaEcuacion(sbEcuacion);
}
	
//Por compatibilidad hacia atrs...
float EvalExpr2::fCicloEvalua(float fX, float fY)
{
	fVariable['x'-'a']=fX;
	fVariable['y'-'a']=fY;
	return fRapidoEvalua();
}

	
float EvalExpr2::fEvaluaEcuacion(char *sbEcuacion)
{
	//Elimina los espacios
	char sbEcuacion2[TAMANOEXPRESION];
	sbEcuacion2[0]='(';

	//Quita los espacios
	int iAumenta=1;
	for(unsigned int iCont=0; iCont < strlen(sbEcuacion); iCont++)
		if( sbEcuacion[iCont] != ' ')
			sbEcuacion2[iAumenta++]=sbEcuacion[iCont];
	sbEcuacion2[iAumenta]=')';
	sbEcuacion2[iAumenta+1]='\0';
	//printf("[%s]\n", sbEcuacion2);

	// Desintegra la expresion en Acums
	bPrimeraExpresion = true;
	vOptimizador(sbEcuacion2);

	//Manda a evaluar
	return fRapidoEvalua();
}

//Libera la memoria usada
void EvalExpr2::vLiberaMemoria()
{
	//Crea variable para recorrer la lista
	NodoBus *objTemp = objTopeLista;
	NodoExprCompleja *objComple = NULL;
	while(true)
	{
		if (objTemp->cFuncion == 0)
		{
			objComple = objTemp->objComplejo;
			while (true)
			{
				NodoExprCompleja *objLiberarComple = objComple; //El nodo a liberar
				objComple = objComple->Flecha; //Salta al siguiente nodo
				delete objLiberarComple; //Libera la memoria del nodo anterior
				//printf("Borra NodoExprCompleja\n");
				if (objComple == NULL) break;
			}
		}
		
		//Siguiente expresion
		NodoBus *objLiberaBus = objTemp; //El nodo a liberar
		objTemp = objTemp->FlechaD; //Salta al siguiente nodo
		delete objLiberaBus; //Libera la memoria del nodo anterior
		//printf("Borra NodoBus\n");
		if (objTemp == NULL) break;
	}
}

// Convierte la expresion en Acums
void EvalExpr2::vOptimizador(char *sbEcuacion)
{
	int iCont1, iCont2=0, iFuncion;

	//Inicia el contador de acums
	iNumAcums = 0;

	//Variables para depositar los acums y el cambio de la cadena
	char  sbSubExpresion[TAMANOEXPRESION];
	char  sbParteIni[TAMANOEXPRESION];
	char  sbParteFin[TAMANOEXPRESION];

	//Las tres letras que conforma una funcin
	char cFuncA, cFuncB, cFuncC;
		
	do
	{
		// Busca parentesis '(' de derecha a izquierda
		for (iCont1=strlen(sbEcuacion)-1; iCont1>=0; iCont1--)
		{
			if (sbEcuacion[iCont1] == ')' ) iCont2=iCont1;
			if (sbEcuacion[iCont1] == '(' ) break;
		}
		
		//Busca la pareja del '(', es decir: ')'
		if (iCont1>=0)
		{
			//Extraigo la subcadena entre parentesis y lo coloco en los acums y de una vez la desintegro
			vMid(sbSubExpresion, sbEcuacion, iCont1+2, iCont2);

			//Creo la nueva subexpresion
			vNuevoAcumulado(sbSubExpresion);
			
			// Cambio la ecuacion por la nueva expresion basada en acums
			vLeft(sbParteIni, sbEcuacion, iCont1);
			vMid2(sbParteFin, sbEcuacion, iCont2+2);
			strcpy(sbEcuacion, sbParteIni);
			sbEcuacion[iCont1]=(char)(iNumAcums+123);
			sbEcuacion[iCont1+1]='\0';
			strcat(sbEcuacion, sbParteFin);

			//Aumento el nmero de subexpresiones que hay
			iNumAcums++;
			
			//Chequeo si las tres letras anteriores corresponden a una funcion
			if (iCont1 >= 3)
			{
				cFuncA = sbEcuacion[iCont1-3];
				cFuncB = sbEcuacion[iCont1-2];
				cFuncC = sbEcuacion[iCont1-1];
				for (iFuncion=1; iFuncion<=13; iFuncion++)
				{
					if (cFuncA == sbFuncion[iFuncion][0] && 
					    cFuncB == sbFuncion[iFuncion][1] &&
					    cFuncC == sbFuncion[iFuncion][2])
					{
						vMid(sbParteIni, sbEcuacion, 1, iCont1-3);
						vMid2(sbParteFin, sbEcuacion, iCont1+2);
						strcpy(sbEcuacion, sbParteIni);
						sbEcuacion[iCont1-3]=(char)(iNumAcums+123);
						sbEcuacion[iCont1-2]='\0';
						strcat(sbEcuacion, sbParteFin);
						
						objBus = new NodoBus(objBus);
						objBus->iCodigo=iNumAcums;
						objBus->cFuncion=(char)iFuncion;
						iNumAcums++;
					}
				}
			}
		}
	} while (iCont1 > 0);
}

//Genera una lista simplemente enlazada con todos los acums
void EvalExpr2::vNuevoAcumulado(char *sbExpresion)
{
	//Convierte algo como -5+3*x en 0-5+3*x
	char sbExprTmp[TAMANOEXPRESION];
	if (sbExpresion[0]=='-')
	{
		sbExprTmp[0]='0';
		sbExprTmp[1]='\0';
		strcat(sbExprTmp, sbExpresion);
	}
	else
		strcpy(sbExprTmp, sbExpresion);
	strcat(sbExprTmp, "N"); //Finaliza siempre en operador N
	
	//Crea un nuevo acumulado en la lista simplemente enlazada
	if (bPrimeraExpresion)
	{
		objBus = new NodoBus();
		objTopeLista = objBus;
		bPrimeraExpresion = false;
	}
	else
		objBus = new NodoBus(objBus);	
	
	//Prepara todo para llenar el nodo
	char sbNumero[50]; //Variable que lleva el acumulado de los numeros (hasta 50 numeros)
	sbNumero[0]='\0';
	unsigned int iNumero=0;

	float fNumero; //Valor del numero de String a float
	char cTipo='0'; //Tipo de dato: Numero+Operador Variable+Operador Acumulado+Operador
	unsigned int iAcumular=0; //Acumulado
	unsigned char cCaracter, cVariable='a';
	
	//Crea la subexpresin dentro de la lista NodoBus
	objBus->iCodigo = iNumAcums;
	objBus->cFuncion = 0; //No es una funcion, es una expresin del tipo a+b*c/d

	for(unsigned int iChar=0; iChar < (unsigned int) strlen(sbExprTmp); iChar++)
	{
		cCaracter=sbExprTmp[(signed) iChar];

		//Si son numeros entonces
		if ( (cCaracter >= '0' && cCaracter <= '9' ) || cCaracter=='.')
		{
			cTipo = '0';
			sbNumero[iNumero++]= sbExprTmp[(signed) iChar];
			sbNumero[iNumero]='\0';
		}

		//Si son variables entonces
		if (cCaracter >= 'a' && cCaracter <= 'z')
		{
			cTipo = '1';
			cVariable = cCaracter;
		}
			
		//Si son acumulados entonces
		if (cCaracter >= 123)
		{
			cTipo = '2';
			iAcumular = (unsigned int) cCaracter - 123;
		}
			
		//Si son operadores
		if (cCaracter == '*' || cCaracter == '/' || cCaracter == '-' || cCaracter == '^' || cCaracter == '%' || cCaracter == '+' || cCaracter == 'N')
		{
			//Tipo 1. Numero y operador
			switch(cTipo)  //Tipo de dato: Numero+Operador Variable+Operador Acumulado+Operador
			{
				case '0':	fNumero = (float) atof(sbNumero);
							objBus->vAdiciona('0', fNumero, '0', 0, cCaracter);
							sbNumero[0]='\0';
							iNumero=0;
							break;
				case '1':   objBus->vAdiciona('1', 0, cVariable, 0, cCaracter);
							break;
				case '2':   objBus->vAdiciona('2', 0, '0', iAcumular, cCaracter);
							break;
			}
		}
	} // Fin for
}

/* Esta rutina evalua rpidamente la expresin porque ya esta pre-analizada */
float EvalExpr2::fRapidoEvalua()
{
	float fValor, fAcumulado;
	
	//Empieza sin error matematico
	ERRORMATEMATICO = 0;
		
	//Crea variable para recorrer la lista
	NodoBus *objTemp = objTopeLista;

	/* Tiene que armarse asi la expresion compleja y sale mas rpido
	 * De: 30 + 20 - 10
	 * A:  [10 N] -> [20 -] -> [30 +] -> null
	 *
	 * */
	NodoExprCompleja *objComple = NULL;

	while(true)
	{
		//Para una funcion (sin, cos, tan) hace esto
		if (objTemp->cFuncion > 0)
		{
			switch(objTemp->cFuncion)
			{
				case 1:
				case 2: //Seno
						fAcumular[objTemp->iCodigo] = sin(fAcumular[objTemp->iCodigo-1]);
						break;
				case 3: //Coseno
						fAcumular[objTemp->iCodigo] = cos(fAcumular[objTemp->iCodigo-1]);
						break;
				case 4: //Tangente
						fAcumular[objTemp->iCodigo] = tan(fAcumular[objTemp->iCodigo-1]);
						break;
				case 5: //valor absoluto
						fAcumular[objTemp->iCodigo] = (float) fabs(fAcumular[objTemp->iCodigo-1]);
						break;
				case 6: //arcoseno
					if (fAcumular[objTemp->iCodigo-1] >= -1 && fAcumular[objTemp->iCodigo-1] <= 1)
						fAcumular[objTemp->iCodigo] = (float) asin(fAcumular[objTemp->iCodigo-1]);
					else
					{
						fAcumular[objTemp->iCodigo] = 0;
						ERRORMATEMATICO = 3;
						return 0;
					}
					break;
				case 7: //arcocoseno
					if (fAcumular[objTemp->iCodigo-1] >= -1 && fAcumular[objTemp->iCodigo-1] <= 1)
						fAcumular[objTemp->iCodigo] = (float) acos(fAcumular[objTemp->iCodigo-1]);
					else
					{
						fAcumular[objTemp->iCodigo] = 0;
						ERRORMATEMATICO = 3;
						return 0;
					}
				case 8: //arcotangente
						fAcumular[objTemp->iCodigo] = (float) atan(fAcumular[objTemp->iCodigo-1]);
						break;
				case 9: //Logaritmo
						fAcumular[objTemp->iCodigo] = (float) log(fAcumular[objTemp->iCodigo-1]);
						break;
				case 10: //Valor entero redondeado
						fAcumular[objTemp->iCodigo] = (float) (fAcumular[objTemp->iCodigo-1]);
						break;
				case 11: //Exponencial
						fAcumular[objTemp->iCodigo] = (float) exp(fAcumular[objTemp->iCodigo-1]);
						break;
				case 12: //Raiz Cuadrada
						fAcumular[objTemp->iCodigo] = (float) sqrt(fAcumular[objTemp->iCodigo-1]);
						break;
				case 13: //Raiz Cubica
						fAcumular[objTemp->iCodigo] = (float) pow(fAcumular[objTemp->iCodigo-1], (float) 1/3);
						break;
			}
		}
		else //En caso de no ser funcion
		{
			//Para traer la subexpresion
			objComple = objTemp->objComplejo;
			objNodo = NULL;
		
   			/* Copia la expresin compleja a la expresin simple pero ya dando
     	 	* los valores que son y queda de este modo:
     	 	*
     	 	* [30 +] -> [20 -] -> [10 N] -> null
     	 	*
     		**/
			while (true)
    		{
    			switch(objComple->cTipo)
    			{
    				case '0': /* Solo es el valor y el operador */
							//printf("[0] %f %c\n", objComple->fNumero, objComple->cOperador);  
    						objNodo = new NodoExprSimple(objComple->fNumero, objComple->cOperador, objNodo);
    						break;
	   				case '1': /* Es la variable y el operador */
    						fValor = fVariable[objComple->cVariable-97];
							//printf("[1] %f %c\n", fValor, objComple->cOperador);  
    						objNodo = new NodoExprSimple(fValor, objComple->cOperador, objNodo);
    						break;
    				case '2': /* Es un acumulado y el operador */
    						fAcumulado = fAcumular[objComple->iAcumulador];
							//printf("[2] %f %c\n", fAcumulado, objComple->cOperador);  
	   						objNodo = new NodoExprSimple(fAcumulado, objComple->cOperador, objNodo);
    						break;
    			}
				objComple = objComple->Flecha;
				if (objComple == NULL) break;
			} 
    		//printf("Evalua\n");

    		//Evalua la expresin simple
    		fAcumular[objTemp->iCodigo] = fExpresionSimple();
    	}
		//printf("objTemp->iCodigo = %d es... fAcumular[objTemp->iCodigo] = %f\n", objTemp->iCodigo, fAcumular[objTemp->iCodigo]);
    	
    	//Siguiente expresion
    	objTemp = objTemp->FlechaD;
    	if (objTemp == NULL) break;
	}
	
	//Devuelve el valor de la expresin
	if (ERRORMATEMATICO != 0)
		return 0;
	else
		return fAcumular[iNumAcums-1];
}


float EvalExpr2::fExpresionSimple()
{
	//Guarda la primera posicin
	NodoExprSimple *Cabecera = objNodo;

	// ####################### Exponenciacin  #######################
	NodoExprSimple *Temporal;
	while(true)
	{
		if (objNodo->cOperador == '^')
		{
			Temporal = objNodo->Flecha;
			if (objNodo->fNumero < 0 && (Temporal->fNumero - (int) Temporal->fNumero) != 0 )
			{
				objNodo->fNumero = 0;
				ERRORMATEMATICO = 1;	
			}		
			else
			    objNodo->fNumero = pow(objNodo->fNumero, Temporal->fNumero);
			objNodo->cOperador = Temporal->cOperador;
			objNodo->Flecha = Temporal->Flecha;

			//printf("Libera NodoExprSimple\n");
			delete Temporal; //Libera la memoria
		}
		else
	        objNodo = objNodo->Flecha;
		if (objNodo==NULL) break;
	}
	objNodo = Cabecera; //Restaura primera posicion

	// ####################### Hace la modulacin, divisin y multiplicacin #######################
	while(true)
	{
		switch(objNodo->cOperador)
		{
			case '%':
				Temporal = objNodo->Flecha;
				if (Temporal->fNumero == 0)
				{
					ERRORMATEMATICO = 2;
					objNodo->fNumero = 0;
				}
				else
				    objNodo->fNumero = fmod(objNodo->fNumero, Temporal->fNumero);
				objNodo->cOperador = Temporal->cOperador;
				objNodo->Flecha = Temporal->Flecha;
				delete Temporal; //Libera la memoria
				break;
			case '/':
				Temporal = objNodo->Flecha;
				if (Temporal->fNumero == 0)
				{
					ERRORMATEMATICO = 2;
					objNodo->fNumero = 0;
				}
				else
					objNodo->fNumero = objNodo->fNumero / Temporal->fNumero;
				objNodo->cOperador = Temporal->cOperador;
				objNodo->Flecha = Temporal->Flecha;
				delete Temporal; //Libera la memoria
				break;
			case '*':
				Temporal = objNodo->Flecha;
				objNodo->fNumero = objNodo->fNumero * Temporal->fNumero;
				objNodo->cOperador = Temporal->cOperador;
				objNodo->Flecha = Temporal->Flecha;
				delete Temporal; //Libera la memoria
				break;
			default: objNodo = objNodo->Flecha;
		}
		if (objNodo==NULL) break;
	}
		
	//Restaura primera posicion
	objNodo = Cabecera;

	// ####################### Hace la suma y resta #######################
	float fTotal = objNodo->fNumero;
	char cOperador = objNodo->cOperador;
	while (cOperador!='N')
	{
		Temporal = objNodo;
    	objNodo = objNodo->Flecha;
		delete Temporal;
    	if (cOperador == '+')
 			fTotal += objNodo->fNumero;
    	else
 			fTotal -= objNodo->fNumero;
 		cOperador = objNodo->cOperador;
	}
	if (objNodo!=NULL) delete objNodo;
	return fTotal;
}

EvalExpr2::~EvalExpr2(void)
{
}

// Toma las primeras cNumLetras de la cadena sCadenaOrigen y las deposita en sCadenaDestino
void EvalExpr2::vLeft(char *sCadenaDestino, char *sCadenaOrigen, unsigned int iNumLetras)
{
 unsigned int iCont;
 for(iCont=0; iCont<=iNumLetras-1 && *(sCadenaOrigen+iCont); iCont++) *(sCadenaDestino+iCont)=*(sCadenaOrigen+iCont);
 *(sCadenaDestino+iCont)='\0';
};

// Extrae una subcadena de sCadenaOrigen y la deposita en sCadenaDestino
void EvalExpr2::vMid(char *sCadenaDestino, char *sCadenaOrigen, unsigned int iDesde, unsigned int iHasta)
{
 unsigned int iCont1, iCont2;
 for(iCont2=0, iCont1=iDesde-1; iCont1<=iHasta-1 && *(sCadenaOrigen+iCont1); iCont2++, iCont1++) *(sCadenaDestino+iCont2)=*(sCadenaOrigen+iCont1);
	*(sCadenaDestino+iCont2)='\0';
};

//Extrae la cadena desde determinada posicion
void EvalExpr2::vMid2(char *sCadenaDestino, char *sCadenaOrigen, unsigned int iDesde)
{
 unsigned int iCont1, iCont2;
 for(iCont2=0, iCont1=iDesde-1; *(sCadenaOrigen+iCont1); iCont2++, iCont1++) *(sCadenaDestino+iCont2)=*(sCadenaOrigen+iCont1);
	*(sCadenaDestino+iCont2)='\0';
};
